//
//  NSString+Empty.m
//  MacPass
//
//  Created by Michael Starke on 24.06.13.
//  Copyright (c) 2013 HicknHack Software GmbH. All rights reserved.
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#import "NSString+KPKEmpty.h"

@implementation NSString (Empty)

+ (NSSet<NSString *> *)keyPathsForValuesAffectingKpk_isNotEmpty {
  return [NSSet setWithObject:NSStringFromSelector(@selector(length))];
}

- (BOOL)kpk_isNotEmpty {
  /*
   nil objects should not get this message.
   if for some reason they do, length is 0 so the return NO correctly
  */
  return (self.length != 0);
}

@end
